<?php
/**
 * @package    Cynergy Software PDF Component
  * @Copyright Copyright 2010, Cynergy Software
 * @subpackage Components
 * @link http://docs.joomla.org/Developing_a_Model-View-Controller_Component_-_Part_1
 * @license    GNU/GPL
 *    This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, version 3 of the License
 *
 *   The Cynergy-Software PDF component is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with the Cynergy Software PDF component.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 *   This file is part of The Cynergy-Software PDF component.
 *
 *   Cynergy-Software PDF component is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, version 3 of the License.
 *
 *   Cynergy-Software PDF component is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with Cynergy-Software PDF component.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
 
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();
 include "archive.php";
jimport( 'joomla.application.component.model' );
 
/**
 * Hello Model
 *
 * @package    Joomla.Tutorials
 * @subpackage Components
 */
class CynergyPDFModelEditPage extends JModel
{
    /**
     * Hellos data array
     *
     * @var array
     */
    var $_data;
 
    /**
     * Returns the query
     * @return string The query to be used to retrieve the rows from the database
     */
  function __construct()
{
    parent::__construct(); 
 
    $array = JRequest::getVar('cid',  0, '', 'array');
    $this->setId((int)$array[0]);
}
/**
 * Method to set the hello identifier
 *
 * @access    public
 * @param    int Hello identifier
 * @return    void
 */
function setId($id)
{
    // Set id and wipe data
    $this->_id        = $id;
    $this->_data    = null;
}
/**
 * Method to get a hello
 * @return object with data
 */
 
function getData()
{
    // Load the data
    if (empty( $this->_data )&&($this->_id)) {
        $query = ' SELECT * FROM #__cynergypdf '.
                '  WHERE pdf_id = '.$this->_id;
	
        $this->_db->setQuery( $query );
        $this->_data = $this->_db->loadObject();
    }
    if (!$this->_data) {
        $this->_data = new stdClass();
        $this->_data->pdf_id = 0;
        $this->_data->pdf_name = null;
    }
    return $this->_data;
}
function deleteDirectory($dir) {
        if (!file_exists($dir)) return true;
        if (!is_dir($dir)) return unlink($dir);
        foreach (scandir($dir) as $item) {
            if ($item == '.' || $item == '..') continue;
            if (!$this->deleteDirectory($dir.DIRECTORY_SEPARATOR.$item)) return false;
        }
        return rmdir($dir);
    }
function saveData()
{
        
        $pdf_name = JRequest::getString('pdf_name');
        $pdf_id = JRequest::getInt('id');  
        
        if ($pdf_id)
          $query = 'UPDATE #__cynergypdf '.
          'set pdf_name=  '.(string) $this->_db->quote( $this->_db->getEscaped( $pdf_name ), false ).' where pdf_id = '. (int) $pdf_id;
        else
           $query = 'INSERT INTO #__cynergypdf '.
          '(pdf_name) VALUES ('.(string) $this->_db->quote( $this->_db->getEscaped( $pdf_name ), false ).')';
         
         $this->_db->setQuery($query);
          if (!$this->_db->query()) {
                  JError::raiseError( 500, $this->_db->stderr());
                  return $this->_db->stderr();
          }
 
 
          if ($_FILES['pdf_tar']['size']!=0){
            $id= ($pdf_id)?$pdf_id:$this->_db->insertid();
           
            if (!file_exists(JPATH_SITE.'/images/com_cynergypdf/'))
                 mkdir (JPATH_SITE.'/images/com_cynergypdf');
            $this->deleteDirectory(JPATH_SITE.'/images/com_cynergypdf/'.$id);
            if (!mkdir (JPATH_SITE.'/images/com_cynergypdf/'.$id))
              return JText::_( 'Could not make image directory');
            if (!copy ($_FILES['pdf_tar']['tmp_name'],JPATH_SITE.'/images/com_cynergypdf/'.$id.'/tmp.tar'))
                return JText::_( 'Could not copy tar');

            $tar = new tar_file(JPATH_SITE.'/images/com_cynergypdf/'.$id.'/tmp.tar');
            // Overwrite existing files
            $tar->set_options(array('overwrite' => 1, 'basedir'=>JPATH_SITE.'/images/com_cynergypdf/'.$id.'/'));
            
            // Extract contents of archive to disk
            $tar->extract_files();
	    foreach (glob(JPATH_SITE.'/images/com_cynergypdf/'.$id.'/'."*.jpg") as $filename) {
		chmod($filename,0775);
	    }
            //$tar = new Archive_Tar(JPATH_SITE.'/images/com_cynergypdf/'.$id.'/tmp.tar');
            //$tar->extract(JPATH_SITE.'/images/com_cynergypdf/'.$id.'/');
           
            //$xml = new JSimpleXML;
	    $xml = JFactory::getXMLParser('Simple');
            if (!$xml->loadFile(JPATH_SITE.'/images/com_cynergypdf/'.$id.'/pdf.xml')){
                
                return JText::_( 'Could load xml, check the xml format');
              }

            try{
              $numImages=$xml->document->numImages[0];
              $imagePref=$xml->document->imagePref[0];
            if (!$numImages || !$imagePref)
                return JText::_( 'Could not load xml, check the xml format');
            
            
            $numImages=$numImages->data();
            $imagePref=$imagePref->data();
            }
            catch(Exception $e)
            {
              return JText::_( 'Could not load xml, check the xml format');
            }
            $query = 'UPDATE #__cynergypdf '.
            'set num_images=  '.(int) $numImages.', image_prefix= '.(string) $this->_db->quote( $this->_db->getEscaped( $imagePref ), false ).' where pdf_id = '. (int) $id;
           
            $this->_db->setQuery($query);
            if (!$this->_db->query()) {
                    JError::raiseError( 500, $this->_db->stderr());
                    return $this->_db->stderr();
            }
          }
           else {
               return JText::_( 'could not upload cynergy pdf, please check your php upload limits, post_max_size, upload_max_filesize, memory_limit');
          }
          return JText::_( 'pdf saved successfully');
  
}
function cynergypdfCjs(){
         $returnjs= ' <script language="JavaScript" type="text/javascript">

//v1.7
// Flash Player Version Detection
// Detect Client Browser type
// Copyright 2005-2008 Adobe Systems Incorporated.  All rights reserved.
var isIE  = (navigator.appVersion.indexOf("MSIE") != -1) ? true : false;
var isWin = (navigator.appVersion.toLowerCase().indexOf("win") != -1) ? true : false;
var isOpera = (navigator.userAgent.indexOf("Opera") != -1) ? true : false;
function ControlVersion()
{
	var version;
	var axo;
	var e;
	// NOTE : new ActiveXObject(strFoo) throws an exception if strFoo isn\'t in the registry
	try {
		// version will be set for 7.X or greater players
		axo = new ActiveXObject("ShockwaveFlash.ShockwaveFlash.7");
		version = axo.GetVariable("$version");
	} catch (e) {
	}
	if (!version)
	{
		try {
			// version will be set for 6.X players only
			axo = new ActiveXObject("ShockwaveFlash.ShockwaveFlash.6");
			
			// installed player is some revision of 6.0
			// GetVariable("$version") crashes for versions 6.0.22 through 6.0.29,
			// so we have to be careful. 
			
			// default to the first public version
			version = "WIN 6,0,21,0";
			// throws if AllowScripAccess does not exist (introduced in 6.0r47)		
			axo.AllowScriptAccess = "always";
			// safe to call for 6.0r47 or greater
			version = axo.GetVariable("$version");
		} catch (e) {
		}
	}
	if (!version)
	{
		try {
			// version will be set for 4.X or 5.X player
			axo = new ActiveXObject("ShockwaveFlash.ShockwaveFlash.3");
			version = axo.GetVariable("$version");
		} catch (e) {
		}
	}
	if (!version)
	{
		try {
			// version will be set for 3.X player
			axo = new ActiveXObject("ShockwaveFlash.ShockwaveFlash.3");
			version = "WIN 3,0,18,0";
		} catch (e) {
		}
	}
	if (!version)
	{
		try {
			// version will be set for 2.X player
			axo = new ActiveXObject("ShockwaveFlash.ShockwaveFlash");
			version = "WIN 2,0,0,11";
		} catch (e) {
			version = -1;
		}
	}
	
	return version;
}
// JavaScript helper required to detect Flash Player PlugIn version information
function GetSwfVer(){
	// NS/Opera version >= 3 check for Flash plugin in plugin array
	var flashVer = -1;
	
	if (navigator.plugins != null && navigator.plugins.length > 0) {
		if (navigator.plugins["Shockwave Flash 2.0"] || navigator.plugins["Shockwave Flash"]) {
			var swVer2 = navigator.plugins["Shockwave Flash 2.0"] ? " 2.0" : "";
			var flashDescription = navigator.plugins["Shockwave Flash" + swVer2].description;
			var descArray = flashDescription.split(" ");
			var tempArrayMajor = descArray[2].split(".");			
			var versionMajor = tempArrayMajor[0];
			var versionMinor = tempArrayMajor[1];
			var versionRevision = descArray[3];
			if (versionRevision == "") {
				versionRevision = descArray[4];
			}
			if (versionRevision[0] == "d") {
				versionRevision = versionRevision.substring(1);
			} else if (versionRevision[0] == "r") {
				versionRevision = versionRevision.substring(1);
				if (versionRevision.indexOf("d") > 0) {
					versionRevision = versionRevision.substring(0, versionRevision.indexOf("d"));
				}
			}
			var flashVer = versionMajor + "." + versionMinor + "." + versionRevision;
		}
	}
	// MSN/WebTV 2.6 supports Flash 4
	else if (navigator.userAgent.toLowerCase().indexOf("webtv/2.6") != -1) flashVer = 4;
	// WebTV 2.5 supports Flash 3
	else if (navigator.userAgent.toLowerCase().indexOf("webtv/2.5") != -1) flashVer = 3;
	// older WebTV supports Flash 2
	else if (navigator.userAgent.toLowerCase().indexOf("webtv") != -1) flashVer = 2;
	else if ( isIE && isWin && !isOpera ) {
		flashVer = ControlVersion();
	}	
	return flashVer;
}
// When called with reqMajorVer, reqMinorVer, reqRevision returns true if that version or greater is available
function DetectFlashVer(reqMajorVer, reqMinorVer, reqRevision)
{
	versionStr = GetSwfVer();
	if (versionStr == -1 ) {
		return false;
	} else if (versionStr != 0) {
		if(isIE && isWin && !isOpera) {
			// Given "WIN 2,0,0,11"
			tempArray         = versionStr.split(" "); 	// ["WIN", "2,0,0,11"]
			tempString        = tempArray[1];			// "2,0,0,11"
			versionArray      = tempString.split(",");	// [\'2\', \'0\', \'0\', \'11\']
		} else {
			versionArray      = versionStr.split(".");
		}
		var versionMajor      = versionArray[0];
		var versionMinor      = versionArray[1];
		var versionRevision   = versionArray[2];
        	// is the major.revision >= requested major.revision AND the minor version >= requested minor
		if (versionMajor > parseFloat(reqMajorVer)) {
			return true;
		} else if (versionMajor == parseFloat(reqMajorVer)) {
			if (versionMinor > parseFloat(reqMinorVer))
				return true;
			else if (versionMinor == parseFloat(reqMinorVer)) {
				if (versionRevision >= parseFloat(reqRevision))
					return true;
			}
		}
		return false;
	}
}
function AC_AddExtension(src, ext)
{
  if (src.indexOf(\'?\') != -1)
    return src.replace(/\?/, ext+\'?\'); 
  else
    return src + ext;
}
function AC_Generateobj(objAttrs, params, embedAttrs) 
{ 
  var str = \'\';
  if (isIE && isWin && !isOpera)
  {
    str += \'<object \';
    for (var i in objAttrs)
    {
      str += i + \'="\' + objAttrs[i] + \'" \';
    }
    str += \'>\';
    for (var i in params)
    {
      str += \'<param name="\' + i + \'" value="\' + params[i] + \'" /> \';
    }
    str += \'</object>\';
  }
  else
  {
    str += \'<embed \';
    for (var i in embedAttrs)
    {
      str += i + \'="\' + embedAttrs[i] + \'" \';
    }
    str += \'> </embed>\';
  }
  document.write(str);
}
function AC_FL_RunContent(){
  var ret = 
    AC_GetArgs
    (  arguments, ".swf", "movie", "clsid:d27cdb6e-ae6d-11cf-96b8-444553540000"
     , "application/x-shockwave-flash"
    );
  AC_Generateobj(ret.objAttrs, ret.params, ret.embedAttrs);
}
function AC_SW_RunContent(){
  var ret = 
    AC_GetArgs
    (  arguments, ".dcr", "src", "clsid:166B1BCA-3F9C-11CF-8075-444553540000"
     , null
    );
  AC_Generateobj(ret.objAttrs, ret.params, ret.embedAttrs);
}
function AC_GetArgs(args, ext, srcParamName, classid, mimeType){
  var ret = new Object();
  ret.embedAttrs = new Object();
  ret.params = new Object();
  ret.objAttrs = new Object();
  for (var i=0; i < args.length; i=i+2){
    var currArg = args[i].toLowerCase();    
    switch (currArg){	
      case "classid":
        break;
      case "pluginspage":
        ret.embedAttrs[args[i]] = args[i+1];
        break;
      case "src":
      case "movie":	
        args[i+1] = AC_AddExtension(args[i+1], ext);
        ret.embedAttrs["src"] = args[i+1];
        ret.params[srcParamName] = args[i+1];
        break;
      case "onafterupdate":
      case "onbeforeupdate":
      case "onblur":
      case "oncellchange":
      case "onclick":
      case "ondblclick":
      case "ondrag":
      case "ondragend":
      case "ondragenter":
      case "ondragleave":
      case "ondragover":
      case "ondrop":
      case "onfinish":
      case "onfocus":
      case "onhelp":
      case "onmousedown":
      case "onmouseup":
      case "onmouseover":
      case "onmousemove":
      case "onmouseout":
      case "onkeypress":
      case "onkeydown":
      case "onkeyup":
      case "onload":
      case "onlosecapture":
      case "onpropertychange":
      case "onreadystatechange":
      case "onrowsdelete":
      case "onrowenter":
      case "onrowexit":
      case "onrowsinserted":
      case "onstart":
      case "onscroll":
      case "onbeforeeditfocus":
      case "onactivate":
      case "onbeforedeactivate":
      case "ondeactivate":
      case "type":
      case "codebase":
      case "id":
        ret.objAttrs[args[i]] = args[i+1];
        break;
      case "width":
      case "height":
      case "align":
      case "vspace": 
      case "hspace":
      case "class":
      case "title":
      case "accesskey":
      case "name":
      case "tabindex":
        ret.embedAttrs[args[i]] = ret.objAttrs[args[i]] = args[i+1];
        break;
      default:
        ret.embedAttrs[args[i]] = ret.params[args[i]] = args[i+1];
    }
  }
  ret.objAttrs["classid"] = classid;
  if (mimeType) ret.embedAttrs["type"] = mimeType;
  return ret;
}</script>';
  return $returnjs;
}
function processPDF(){
                        $pdf_id = JRequest::getVar('cid');  
                        
                        $pdf_id=$pdf_id[0];
                      if ($pdf_id){
                        $db =& JFactory::getDBO();
 
   	                $query = 'SELECT * FROM #__cynergypdf where pdf_id='.$pdf_id;
   	                $db->setQuery( $query );

   	                $rowQ = $db->loadAssoc();

	
	                $num_images = $rowQ['num_images'];
                        $image_prefix = $rowQ['image_prefix'];
                        
                        $image_path = JURI::root().'images/com_cynergypdf/'.$pdf_id."/";
                
                
                        for ($j=0; $j < $num_images; $j++)
                        {
                                $returnValue['pages'][$j] = $image_prefix.$j.".jpg";
                        }
                        $returnValue['properties']['nav'] = true;
                        $returnValue['properties']['scrollbarThickness'] = 2;
                        $returnValue['properties']['scrollbarTopMargin'] = 0;
                        $returnValue['properties']['scrollbarHeight'] = 600;
                        $returnValue['properties']['totalPages'] = $num_images;
                        $returnValue['properties']['componentWidth'] = 670;
                        $returnValue['properties']['componentHeight'] = 600;
                        $returnValue['properties']['pageWidth'] = 600;
                        $returnValue['properties']['pageHeight'] = 600;
                        $returnValue['properties']['marginBottom'] = 0;
                        $returnValue['properties']['hasDropShadow'] = 1;
                        $returnValue['properties']['pagesFolder'] = $image_path;

                        $returnValue['properties']['scrollbarColor'] = '0x0000FF';
                        $returnValue['properties']['bgColor'] = '0xFFFFFF';


                        $returnValue['properties']['scrollHandleImage'] = JURI::root().'media/com_cynergypdf/apply_f2.png'; //'images/scrollHandle.png';
                        
                        
                        
                        $paramst= json_encode($returnValue);
                        $paramst=str_replace("\"","'",$paramst);
                        $load= $this->cynergypdfjs($paramst);
                        return $load;
}
}
  protected  function cynergypdfjs($paramst){
           $returnjs= '
<script language="JavaScript" type="text/javascript">
	AC_FL_RunContent(
		\'codebase\', \'http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=10,0,0,0\',
		\'width\', \'670\',
		\'height\', \'600\',
		\'src\', \''.JURI::root().'components/com_cynergypdf/views/doc/cynergyPDF\',
		\'quality\', \'high\',
		\'pluginspage\', \'http://www.adobe.com/go/getflashplayer\',
		\'align\', \'middle\',
		\'play\', \'true\',
		\'loop\', \'true\',
		\'scale\', \'showall\',
		\'wmode\', \'window\',
		\'devicefont\', \'false\',
		\'id\', \'cynergyPDF\',
		\'bgcolor\', \'#ffffff\',
		\'name\', \'cynergyPDF\',
		\'menu\', \'true\',
		\'allowFullScreen\', \'false\',
		\'allowScriptAccess\',\'sameDomain\',
		\'FlashVars\',"data='.$paramst.'",
		\'movie\', \''.JURI::root().'components/com_cynergypdf/views/doc/cynergyPDF\',
		\'salign\', \'\'
		); //end AC code
</script>
<noscript>
	<object classid="clsid:d27cdb6e-ae6d-11cf-96b8-444553540000" codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=10,0,0,0" width="100%" height="100%" id="cynergyPDF" align="middle">
	<param name="allowScriptAccess" value="sameDomain" />
	<param name="allowFullScreen" value="false" />
	<param name="movie" value="cynergyPDF.swf" /><param name="quality" value="high" /><param name="bgcolor" value="#ffffff" />	<embed src="components/com_cynergypdf/views/doc/cynergyPDF.swf" quality="high" bgcolor="#ffffff" width="100%" height="100%" name="cynergyPDF" align="middle" allowScriptAccess="sameDomain" allowFullScreen="false" type="application/x-shockwave-flash" pluginspage="http://www.adobe.com/go/getflashplayer" />
	</object>
</noscript>';
        return $returnjs;
        }

}
